
/*
 * getpath.c  - directory search routines for configuration and support
 *                files.
 *
 *      Contributed by Stefan Luethje <luethje@sl-gw.lake.de>
 *
 *      IPTraf 1.4.0 Copyright (c) Gerard Paul Java 1997, 1998
 */

#include "portable.h"
#include "dirs.h"

#ifdef __DJGPP__
  extern char **__crt0_argv;
  static char *p = NULL;
  static char exe_path [PATH_MAX];
#endif

char *get_path(int dirtype, char *file)
{
    static char path[PATH_MAX];
    char *ptr;
    char *dir, *env = NULL;

    switch (dirtype) {
    case T_WORKDIR:
	dir = WORKDIR;
	env = WORKDIR_ENV;
	break;

    case T_LOGDIR:
	dir = LOGDIR;
	env = LOGDIR_ENV;
	break;

    case T_EXECDIR:
#ifdef __DJGPP__
        if (!__crt0_argv || !__crt0_argv[0])
        {
          dir = EXECDIR;
          break;
        }
        p = strrchr (__crt0_argv[0], '/');
        if (!p)
        {
          dir = EXECDIR;
          break;
        }
        strncpy (exe_path, __crt0_argv[0], (size_t)(p-__crt0_argv[0]));
        dir = exe_path;
#else
        dir = EXECDIR;
#endif
	break;

    default:
	return file;
    }

    if ((dirtype != T_EXECDIR) && (ptr = getenv(env)) != NULL)
	dir = ptr;

    if (dir == NULL || *dir == '\0')
	return file;

    snprintf(path, PATH_MAX - 1, "%s/%s", dir, file);

    return path;
}
